diff --git a/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php b/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php
new file mode 100644
index 0000000..21f7fc7
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Users/UsersControllerTest.php
@@ -0,0 +1,248 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Users;
+
+use Carbon\Carbon;
+use Illuminate\Support\Collection;
+use Tests\Feature\ApiTestCase;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Country;
+use Portal\Events\User\Deleted;
+use Portal\Events\User\UpdatedByAdmin;
+use Portal\Role;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\SessionTransformer;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+class UsersControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/users')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_users_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson('/api/users')
+            ->assertResponseStatus(403);
+    }
+
+    public function test_paginate_all_users()
+    {
+        $user = $this->login();
+
+        $users = factory(User::class)->times(20)->create();
+        $users->push($user);
+
+        $this->getJson('/api/users');
+
+        $transformed = $this->transformCollection(
+            $users->sortByDesc('id')->take(20),
+            new UserTransformer
+        );
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertEquals($response['data'], $transformed);
+        $this->assertEquals($response['meta'], [
+            'current_page' => 1,
+            'from' => 1,
+            'to' => 20,
+            'last_page' => 2,
+            'prev_page_url' => null,
+            'next_page_url' => url("api/users?page=2"),
+            'total' => 21,
+            'per_page' => 20
+        ]);
+    }
+
+    public function test_paginate_users_with_status()
+    {
+        $user = $this->login();
+
+        $activeUsers = factory(User::class)->times(2)->create([
+            'status' => UserStatus::ACTIVE
+        ]);
+
+        $bannedUsers = factory(User::class)->times(5)->create([
+            'status' => UserStatus::BANNED
+        ]);
+
+        $this->getJson('/api/users?status=' . UserStatus::BANNED);
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertCount(5, $response['data']);
+    }
+
+    public function test_paginate_users_on_search()
+    {
+        $user = $this->login();
+
+        $user1 = factory(User::class)->create([
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'email' => 'john.doe@portalapp.io'
+        ]);
+
+        $user2 = factory(User::class)->create([
+            'first_name' => 'Jane',
+            'last_name' => 'Doe',
+            'email' => 'jane.doe@portalapp.io'
+        ]);
+
+        $user3 = factory(User::class)->create([
+            'first_name' => 'Brad',
+            'last_name' => 'Pitt',
+            'email' => 'b.pitt@portalapp.io'
+        ]);
+
+        $this->getJson('/api/users?search=doe');
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertCount(2, $response['data']);
+    }
+
+    public function test_create_user()
+    {
+        $user = $this->login();
+
+        $newUser = factory(User::class)->make();
+
+        $data = array_merge($newUser->toArray(), [
+            'birthday' => $newUser->birthday->format('Y-m-d'),
+            'role' => $newUser->role_id,
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ]);
+
+        $this->postJson('api/users', $data);
+
+        $expected = [
+            'first_name' => $newUser->first_name,
+            'last_name' => $newUser->last_name,
+            'email' => $newUser->email,
+            'username' => $newUser->username,
+            'country_id' => $newUser->country_id,
+            'birthday' => $newUser->birthday->format('Y-m-d'),
+            'phone' => $newUser->phone,
+            'address' => $newUser->address,
+            'status' => UserStatus::ACTIVE,
+            'role_id' => $newUser->role_id
+        ];
+
+        $this->assertResponseStatus(201)
+            ->seeInDatabase('users', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_get_user()
+    {
+        $user = $this->login();
+
+        $this->getJson("api/users/{$user->id}")
+            ->assertResponseOk()
+            ->seeJsonContains(
+                (new UserTransformer)->transform($user)
+            );
+    }
+
+    public function test_get_user_which_does_not_exist()
+    {
+        $user = $this->login();
+
+        $this->getJson("api/users/2")
+            ->assertResponseStatus(404);
+    }
+
+    public function test_update_user()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $user = $this->login();
+
+        $data = [
+            'email' => 'john.doe@test.com',
+            'username' => 'john.doe',
+            'password' => '123123',
+            'password_confirmation' => '123123',
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'phone' => '+38123456789',
+            'address' => 'Some random address',
+            'country_id' => Country::first()->id,
+            'birthday' => '1990-10-18',
+            'status' => UserStatus::BANNED,
+            'role_id' => Role::whereName('User')->first()->id
+        ];
+
+        $expected = array_except($data, ['password', 'password_confirmation']);
+        $expected += ['id' => $user->id];
+
+        $this->patchJson("api/users/{$user->id}", $data)
+            ->assertResponseOk()
+            ->seeInDatabase('users', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_update_only_specific_field()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $user = $this->login();
+
+        $data = [
+            'email' => 'john.doe@test.com',
+        ];
+
+        $expected = array_merge(
+            $user->toArray(),
+            $data,
+            ['birthday' => $user->birthday->format('Y-m-d')]
+        );
+
+        $expected = array_except($expected, ['created_at', 'updated_at', 'avatar', 'role']);
+
+        $this->patchJson("api/users/{$user->id}", $data)
+            ->assertResponseOk()
+            ->seeInDatabase('users', $expected)
+            ->seeJsonContains($expected);
+    }
+
+    public function test_delete_user()
+    {
+        $this->expectsEvents(Deleted::class);
+
+        $user = $this->login();
+
+        $user2 = factory(User::class)->create();
+
+        $this->deleteJson("api/users/{$user2->id}")
+            ->assertResponseOk()
+            ->seeJsonContains(['success' => true]);
+    }
+
+    public function test_delete_yourself()
+    {
+        $user = $this->login();
+
+        $this->deleteJson("api/users/{$user->id}")
+            ->assertResponseStatus(403)
+            ->seeJsonContains(['error' => "You cannot delete yourself."]);
+    }
+
+    protected function login()
+    {
+        $user = parent::login();
+
+        $this->addPermissionForUser($user, 'users.manage');
+
+        return $user;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/ActivityControllerTest.php b/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
similarity index 98%
rename from tests/Feature/Http/Controllers/ActivityControllerTest.php
rename to tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
index 27b1e95..2fbc295 100644
--- a/tests/Feature/Http/Controllers/ActivityControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/ActivityControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Input;
 use Tests\Feature\FunctionalTestCase;
diff --git a/tests/Feature/Http/Controllers/Auth/AuthControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
similarity index 97%
rename from tests/Feature/Http/Controllers/Auth/AuthControllerTest.php
rename to tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
index 01be7e0..0449416 100644
--- a/tests/Feature/Http/Controllers/Auth/AuthControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/AuthControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers\Auth;
+namespace Tests\Feature\Http\Controllers\Web\Auth;
 
 use Authy;
 use Mockery;
@@ -142,11 +142,10 @@ class AuthControllerTest extends FunctionalTestCase
         $this->setSettings([
             'reg_enabled' => true,
             'reg_email_confirmation' => true,
-            'registration.captcha.enabled' => false
+            'registration.captcha.enabled' => false,
+            'tos' => true
         ]);
 
-        $this->expectsEvents(Registered::class);
-
         $data = $this->getRegistrationFormStubData();
 
         $this->registerUser($data);
@@ -187,7 +186,8 @@ class AuthControllerTest extends FunctionalTestCase
             'reg_enabled' => true,
             'reg_email_confirmation' => false,
             'notifications_signup_email' => false,
-            'registration.captcha.enabled' => false
+            'registration.captcha.enabled' => false,
+            'tos' => true
         ]);
 
         $this->expectsEvents(Registered::class);
@@ -212,7 +212,8 @@ class AuthControllerTest extends FunctionalTestCase
             'reg_enabled' => true,
             'reg_email_confirmation' => false,
             'notifications_signup_email' => true,
-            'registration.captcha.enabled' => false
+            'registration.captcha.enabled' => false,
+            'tos' => true
         ]);
 
         $adminRole = Role::where('name', 'Admin')->first();
diff --git a/tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
similarity index 98%
rename from tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php
rename to tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
index 02ed9b1..74a44d5 100644
--- a/tests/Feature/Http/Controllers/Auth/PasswordControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/PasswordControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers\Authy;
+namespace Tests\Feature\Http\Controllers\Web\Auth;
 
 use DB;
 use Hash;
diff --git a/tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php b/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
similarity index 99%
rename from tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php
rename to tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
index eaea694..6415865 100644
--- a/tests/Feature/Http/Controllers/Auth/SocialAuthControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/Auth/SocialAuthControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers\Auth;
+namespace Tests\Feature\Http\Controllers\Web\Auth;
 
 use Auth;
 use DB;
diff --git a/tests/Feature/Http/Controllers/PermissionsControllerTest.php b/tests/Feature/Http/Controllers/Web/PermissionsControllerTest.php
similarity index 99%
rename from tests/Feature/Http/Controllers/PermissionsControllerTest.php
rename to tests/Feature/Http/Controllers/Web/PermissionsControllerTest.php
index dca1a50..aadbdfa 100644
--- a/tests/Feature/Http/Controllers/PermissionsControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/PermissionsControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Tests\Feature\FunctionalTestCase;
 use Portal\Events\Permission\Created;
diff --git a/tests/Feature/Http/Controllers/ProfileControllerTest.php b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
similarity index 93%
rename from tests/Feature/Http/Controllers/ProfileControllerTest.php
rename to tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
index f7b7da7..772353a 100644
--- a/tests/Feature/Http/Controllers/ProfileControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/ProfileControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Authy;
 use Hash;
@@ -49,7 +49,7 @@ class ProfileControllerTest extends FunctionalTestCase
         $data = $this->getStubDetailsData();
 
         $extendedData = $data + [
-            'role' => Role::whereName('Admin')->first()->id,
+            'role_id' => Role::whereName('Admin')->first()->id,
             'status' => UserStatus::BANNED,
         ];
 
@@ -141,24 +141,6 @@ class ProfileControllerTest extends FunctionalTestCase
         $this->seeInDatabase('users', ['id' => $this->user->id, 'avatar' => $data['url']]);
     }
 
-    public function test_update_social_networks()
-    {
-        $data = [
-            'facebook' => 'facebook',
-            'twitter' => 'twitter',
-            'google_plus' => 'g+',
-            'linked_in' => 'li',
-            'dribbble' => 'Dribble',
-            'skype' => 'skyyype'
-        ];
-
-        $this->visit("profile")
-            ->submitForm('Update Social Networks', ['socials' => $data])
-            ->seeInDatabase('user_social_networks', $data)
-            ->seePageIs("profile")
-            ->see("Social networks updated successfully.");
-    }
-
     public function test_update_user_login_details()
     {
         $data = [
diff --git a/tests/Feature/Http/Controllers/RolesControllerTest.php b/tests/Feature/Http/Controllers/Web/RolesControllerTest.php
similarity index 98%
rename from tests/Feature/Http/Controllers/RolesControllerTest.php
rename to tests/Feature/Http/Controllers/Web/RolesControllerTest.php
index 6ee121f..c824149 100644
--- a/tests/Feature/Http/Controllers/RolesControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/RolesControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Tests\Feature\FunctionalTestCase;
 use Portal\Role;
diff --git a/tests/Feature/Http/Controllers/SettingsControllerTest.php b/tests/Feature/Http/Controllers/Web/SettingsControllerTest.php
similarity index 94%
rename from tests/Feature/Http/Controllers/SettingsControllerTest.php
rename to tests/Feature/Http/Controllers/Web/SettingsControllerTest.php
index ea9b424..4ebfb9e 100644
--- a/tests/Feature/Http/Controllers/SettingsControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/SettingsControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Settings;
 use Tests\Feature\FunctionalTestCase;
diff --git a/tests/Feature/Http/Controllers/UsersControllerTest.php b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
similarity index 89%
rename from tests/Feature/Http/Controllers/UsersControllerTest.php
rename to tests/Feature/Http/Controllers/Web/UsersControllerTest.php
index afeb1cd..21ae1f1 100644
--- a/tests/Feature/Http/Controllers/UsersControllerTest.php
+++ b/tests/Feature/Http/Controllers/Web/UsersControllerTest.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Tests\Feature\Http\Controllers;
+namespace Tests\Feature\Http\Controllers\Web;
 
 use Authy;
 use Hash;
@@ -29,7 +29,7 @@ class UsersControllerTest extends FunctionalTestCase
         $users = $active->merge($banned);
         $users = $users->merge($unconfirmed);
 
-        $users = $users->reverse();
+        $users = $users->sortByDesc('id')->values();
 
         $this->visit('user')
             ->seeInElement("h1.page-header", "Users")
@@ -72,8 +72,8 @@ class UsersControllerTest extends FunctionalTestCase
             ->submitForm('search-users-btn', ['search' => 'doe'])
             ->seePageIs('user?search=doe&status=')
             ->seeInField('search', 'doe')
-            ->seeInTable('table', $user2->present()->name, 1, 2)
-            ->seeInTable('table', $user3->present()->name, 2, 2);
+            ->seeInTable('table', $user3->present()->name, 1, 2)
+            ->seeInTable('table', $user2->present()->name, 2, 2);
     }
 
     public function test_users_filter_by_status()
@@ -103,7 +103,7 @@ class UsersControllerTest extends FunctionalTestCase
 
         $user = User::where('email', $data['email'])->first();
 
-        $expected = array_except($data, ['role', 'password', 'password_confirmation']);
+        $expected = array_except($data, ['password', 'password_confirmation']);
 
         $this->seeInDatabase('users', $expected)
             ->seePageIs('user')
@@ -126,7 +126,7 @@ class UsersControllerTest extends FunctionalTestCase
 
         $user = User::where('email', $data['email'])->first();
 
-        $expected = array_except($data, ['role', 'password', 'password_confirmation']);
+        $expected = array_except($data, ['password', 'password_confirmation']);
         $expected['country_id'] = null;
 
         $this->seeInDatabase('users', $expected)
@@ -172,7 +172,7 @@ class UsersControllerTest extends FunctionalTestCase
 
         $this->createAndLoginAdminUser();
 
-        $user = $this->createUserWithSocialNetworks();
+        $user = $this->createUser();
         $user = $this->setRoleForUser($user, 'User');
 
         $this->visit('user')
@@ -181,7 +181,7 @@ class UsersControllerTest extends FunctionalTestCase
         $this->visit("user/{$user->id}/edit");
 
         $data = [
-            'role' => Role::whereName('User')->first()->id,
+            'role_id' => Role::whereName('User')->first()->id,
             'status' => UserStatus::BANNED,
             'first_name' => 'foo',
             'last_name' => 'bar',
@@ -193,33 +193,13 @@ class UsersControllerTest extends FunctionalTestCase
 
         $this->submitForm('update-details-btn', $data);
 
-        $expected = array_except($data, 'role') + ['id' => $user->id, 'role_id' => $data['role']];
+        $expected = $data + ['id' => $user->id];
 
         $this->seeInDatabase('users', $expected)
             ->seePageIs("user/{$user->id}/edit")
             ->see('User updated successfully.');
     }
 
-    public function test_update_user_social_networks()
-    {
-        $user = $this->createAndLoginAdminUser();
-
-        $data = [
-            'facebook' => 'facebook',
-            'twitter' => 'twitter',
-            'google_plus' => 'g+',
-            'linked_in' => 'li',
-            'dribbble' => 'Dribble',
-            'skype' => 'skyyype'
-        ];
-
-        $this->visit("user/{$user->id}/edit")
-            ->submitForm('Update Social Networks', ['socials' => $data])
-            ->seeInDatabase('user_social_networks', $data)
-            ->seePageIs("user/{$user->id}/edit")
-            ->see("Social networks updated successfully.");
-    }
-
     public function test_update_user_login_details()
     {
         $user = $this->createAndLoginAdminUser([
@@ -424,7 +404,7 @@ class UsersControllerTest extends FunctionalTestCase
     {
         $this->createAndLoginAdminUser();
 
-        $user = $this->createUserWithSocialNetworks();
+        $user = $this->createUser();
         $user = $this->setRoleForUser($user, 'User');
 
         $this->delete(route('user.delete', $user->id))
@@ -450,7 +430,7 @@ class UsersControllerTest extends FunctionalTestCase
     private function stubUserData(array $override = [])
     {
         return array_merge([
-            'role' => Role::where('name', 'User')->first()->id,
+            'role_id' => Role::where('name', 'User')->first()->id,
             'status' => UserStatus::ACTIVE,
             'first_name' => 'John',
             'last_name' => 'Doe',
@@ -473,13 +453,4 @@ class UsersControllerTest extends FunctionalTestCase
 
         return $user;
     }
-
-    private function refreshApp()
-    {
-        $this->refreshApplication();
-
-        if ($this->isSQLiteConnection()) {
-            $this->executeCallbacks();
-        }
-    }
 }
diff --git a/tests/Feature/Listeners/BaseListenerTestCase.php b/tests/Feature/Listeners/BaseListenerTestCase.php
index 9f4a5cb..24398a3 100644
--- a/tests/Feature/Listeners/BaseListenerTestCase.php
+++ b/tests/Feature/Listeners/BaseListenerTestCase.php
@@ -17,13 +17,13 @@ class BaseListenerTestCase extends FunctionalTestCase
         $this->be($this->user);
     }
 
-    protected function assertMessageLogged($msg)
+    protected function assertMessageLogged($msg, $user = null)
     {
         $this->seeInDatabase('user_activity', [
-            'user_id' => $this->user->id,
+            'user_id' => $user ? $user->id : $this->user->id,
             'ip_address' => Input::ip(),
             'user_agent' => Input::header('User-agent'),
             'description' => $msg
         ]);
     }
-}
\ No newline at end of file
+}
diff --git a/tests/Feature/Listeners/UserEventsSubscriberTest.php b/tests/Feature/Listeners/UserEventsSubscriberTest.php
index a968284..1cf2f9e 100644
--- a/tests/Feature/Listeners/UserEventsSubscriberTest.php
+++ b/tests/Feature/Listeners/UserEventsSubscriberTest.php
@@ -3,6 +3,8 @@
 namespace Tests\Feature\Listeners;
 
 use Mockery as m;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\User;
 
 class UserEventsSubscriberTest extends BaseListenerTestCase
 {
@@ -28,8 +30,16 @@ class UserEventsSubscriberTest extends BaseListenerTestCase
 
     public function test_onRegister()
     {
-        event(new \Portal\Events\User\Registered($this->user));
-        $this->assertMessageLogged('Created an account.');
+        $this->setSettings([
+            'reg_enabled' => true,
+            'reg_email_confirmation' => true,
+        ]);
+
+        $user = factory(\Portal\User::class)->create();
+
+        event(new \Portal\Events\User\Registered($user));
+
+        $this->assertMessageLogged('Created an account.', $user);
     }
 
     public function test_onAvatarChange()
diff --git a/tests/Feature/Repositories/Session/DbSessionTest.php b/tests/Feature/Repositories/Session/DbSessionTest.php
index 694b222..868ea1e 100644
--- a/tests/Feature/Repositories/Session/DbSessionTest.php
+++ b/tests/Feature/Repositories/Session/DbSessionTest.php
@@ -37,8 +37,8 @@ class DbSessionTest extends FunctionalTestCase
         DB::table('sessions')->insert($data2);
 
         $expected = collect([
-            (object) array_except($data1, ['payload', 'user_id']),
-            (object) array_except($data2, ['payload', 'user_id']),
+            (object) $data1,
+            (object) $data2,
         ]);
         $expected = $expected->sortBy('id')->keyBy('id')->toArray();
 
@@ -65,8 +65,9 @@ class DbSessionTest extends FunctionalTestCase
         DB::table('sessions')->insert($data2);
 
         $expected = collect([
-            (object) array_except($data1, ['payload', 'user_id']),
+            (object) $data1
         ]);
+
         $expected = $expected->sortBy('id')->keyBy('id')->toArray();
 
         $actual = collect($this->repo->getUserSessions($user->id))
@@ -87,7 +88,7 @@ class DbSessionTest extends FunctionalTestCase
         $data = $this->getSessionStubData($user);
         DB::table('sessions')->insert($data);
 
-        $this->repo->invalidateUserSession($user->id, $data['id']);
+        $this->repo->invalidateSession($data['id']);
 
         $this->dontSeeInDatabase('sessions', $data)
             ->seeInDatabase('users', ['remember_token' => null]);
diff --git a/tests/Feature/Repositories/User/EloquentUserTest.php b/tests/Feature/Repositories/User/EloquentUserTest.php
index bc27242..0d68c03 100644
--- a/tests/Feature/Repositories/User/EloquentUserTest.php
+++ b/tests/Feature/Repositories/User/EloquentUserTest.php
@@ -68,31 +68,34 @@ class EloquentUserTest extends FunctionalTestCase
         $this->assertNull($this->repo->findBySocialId('bar', '111'));
     }
 
-    public function test_create()
+    public function test_find_by_session_id()
     {
-        $data = factory(User::class)->make()->toArray();
+        $user = factory(User::class)->create();
 
-        $this->repo->create($data + ['password' => 'foo']);
+        $sessionId = str_random(40);
 
-        $this->seeInDatabase('users', $data);
+        DB::table('sessions')->insert([
+            'id' => $sessionId,
+            'user_id' => $user->id,
+            'ip_address' => "127.0.0.1",
+            'user_agent' => "foo",
+            'payload' => str_random(),
+            'last_activity' => Carbon::now()
+        ]);
+
+        $this->assertArraySubset(
+            $user->toArray(),
+            $this->repo->findBySessionId($sessionId)->toArray()
+        );
     }
 
-    public function test_create_without_country()
+    public function test_create()
     {
-        $data1 = factory(User::class)->make(['country_id' => "0"])->toArray();
-        $data2 = factory(User::class)->make(['country_id' => 0])->toArray();
-
-        $this->repo->create($data1 + ['password' => 'foo']);
-        $this->repo->create($data2 + ['password' => 'bar']);
-
-        $expected1 = $data1;
-        $expected1['country_id'] = null;
+        $data = factory(User::class)->make()->toArray();
 
-        $expected2 = $data2;
-        $expected2['country_id'] = null;
+        $this->repo->create($data + ['password' => 'foo']);
 
-        $this->seeInDatabase('users', $expected1);
-        $this->seeInDatabase('users', $expected2);
+        $this->seeInDatabase('users', $data);
     }
 
     public function test_associateSocialAccountForUser()
@@ -120,6 +123,7 @@ class EloquentUserTest extends FunctionalTestCase
     public function test_paginate()
     {
         $users = factory(User::class)->times(5)->create();
+        $users = $users->sortByDesc('id')->values();
 
         $result = $this->repo->paginate(2)->toArray();
 
@@ -172,55 +176,6 @@ class EloquentUserTest extends FunctionalTestCase
         $this->seeInDatabase('users', $data + ['id' => $user->id]);
     }
 
-    public function test_update_without_country()
-    {
-        $user1 = factory(User::class)->create();
-        $user2 = factory(User::class)->create();
-
-        $data = [
-            'first_name' => 'John',
-            'last_name' => 'Doe',
-            'username' => 'foo',
-            'email' => 'test@test.com',
-            'country_id' => "0"
-        ];
-
-        $data2 = [
-            'first_name' => 'Jane',
-            'last_name' => 'Doe',
-            'username' => 'bar',
-            'email' => 'test2@test.com',
-            'country_id' => 0
-        ];
-
-        $this->repo->update($user1->id, $data);
-        $this->repo->update($user2->id, $data2);
-
-        $data['country_id'] = null;
-        $data2['country_id'] = null;
-
-        $this->seeInDatabase('users', $data + ['id' => $user1->id]);
-        $this->seeInDatabase('users', $data2 + ['id' => $user2->id]);
-    }
-
-    public function test_updateSocialNetworks()
-    {
-        $user = factory(User::class)->create();
-
-        $data = [
-            'facebook' => 'foo',
-            'twitter' => 'bar',
-            'dribbble' => 'bazz',
-            'skype' => 'skyyyype',
-            'linked_in' => 'li',
-            'google_plus' => 'g+'
-        ];
-
-        $this->repo->updateSocialNetworks($user->id, $data);
-
-        $this->seeInDatabase('user_social_networks', $data + ['user_id' => $user->id]);
-    }
-
     public function test_delete()
     {
         $user = factory(User::class)->create();
diff --git a/tests/Feature/Services/Auth/Api/TokenFactoryTest.php b/tests/Feature/Services/Auth/Api/TokenFactoryTest.php
new file mode 100644
index 0000000..f894a48
--- /dev/null
+++ b/tests/Feature/Services/Auth/Api/TokenFactoryTest.php
@@ -0,0 +1,101 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth;
+
+use Authy;
+use Carbon\Carbon;
+use Illuminate\Http\Request;
+use JWTAuth;
+use Mockery;
+use Settings;
+use Tests\Feature\FunctionalTestCase;
+use Tests\MailTrap;
+use Portal\Events\User\LoggedIn;
+use Portal\Events\User\Registered;
+use Portal\Role;
+use Portal\Services\Auth\Api\Token;
+use Portal\Services\Auth\Api\TokenFactory;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Mockery as m;
+
+class TokenFactoryTest extends FunctionalTestCase
+{
+    public function test_token_generation_for_user()
+    {
+        Carbon::setTestNow(Carbon::now());
+
+        $user = factory(User::class)->create();
+
+        $factory = new TokenFactory(
+            $this->mockRequest(),
+            $this->mockConfig()
+        );
+
+        $token = $factory->forUser($user);
+
+        $this->seeInDatabase('api_tokens', [
+            'id' => $token->id,
+            'user_id' => $user->id,
+            'ip_address' => '123.456.789.012',
+            'user_agent' => 'fooooo',
+            'expires_at' => Carbon::now()->addMinutes(10)
+        ]);
+    }
+
+    public function test_expired_tokens_cleanup()
+    {
+        Carbon::setTestNow(Carbon::now());
+
+        $user = factory(User::class)->create();
+
+        $expiredToken = factory(Token::class)->create([
+            'user_id' => $user->id,
+            'expires_at' => Carbon::now()->subDay()
+        ]);
+
+        $factory = new TokenFactory(
+            $this->mockRequest(),
+            $this->mockConfig(10, [100, 100])
+        );
+
+        $token = $factory->forUser($user);
+
+        $this->seeInDatabase('api_tokens', [
+            'id' => $token->id,
+            'user_id' => $user->id,
+        ]);
+
+        $this->dontSeeInDatabase('api_tokens', [
+            'id' => $expiredToken->id
+        ]);
+    }
+
+    /**
+     * @param string $ip
+     * @param string $userAgent
+     * @return m\MockInterface
+     */
+    private function mockRequest($ip = '123.456.789.012', $userAgent = 'fooooo')
+    {
+        $request = m::mock(Request::class);
+        $request->shouldReceive('ip')->once()->andReturn($ip);
+        $request->shouldReceive('header')->once()->with('User-Agent')->andReturn($userAgent);
+
+        return $request;
+    }
+
+    /**
+     * @param int $ttl
+     * @param array $lottery
+     * @return m\MockInterface
+     */
+    private function mockConfig($ttl = 10, $lottery = [5, 100])
+    {
+        $config = m::mock(\Illuminate\Contracts\Config\Repository::class);
+        $config->shouldReceive('get')->with('jwt.ttl')->andReturn($ttl);
+        $config->shouldReceive('get')->with('jwt.lottery')->andReturn($lottery);
+
+        return $config;
+    }
+}
